DECLARE FUNCTION InBounds! (checkx!, checky!)
'DEFINT A-Z
'$INCLUDE: 'ugl.bi'
'$INCLUDE: 'kbd.bi'

DECLARE SUB TestJoystick ()
DECLARE SUB OptionsMenu (mu)
DECLARE SUB LoadLevelOrder ()
DECLARE FUNCTION JoyButton2! ()
DECLARE FUNCTION JoyButton1! ()
DECLARE FUNCTION JoyDirection! ()
DECLARE SUB CtrText (txt AS STRING, y!)
DECLARE SUB TitleScreen ()
DECLARE SUB StartWalkSprites ()
DECLARE SUB StartLevel ()
DECLARE SUB Killed ()
DECLARE SUB GrabCoin (xbl, ybl)
DECLARE SUB DoJump ()
DECLARE SUB DoPhysics ()
DECLARE SUB MoveMario (MoveX AS INTEGER, MoveY AS ANY)
DECLARE SUB DispLevel (XOffset AS INTEGER)
DECLARE SUB LoadLevel (levelfile AS STRING)
DECLARE SUB LoadBlocks ()
DECLARE SUB LoadPal (filename AS STRING)

DIM SHARED kbd AS TKBD
DIM SHARED DisplayMode AS INTEGER '0=Normal, 1=Interlaced, 2=Half-res
DIM SHARED Interlacing AS INTEGER
DIM SHARED JoyEnabled AS INTEGER
DIM SHARED TempGfx(340, 100) AS STRING * 1
DIM SHARED NextLevel AS INTEGER
DIM SHARED Blocks(30, 16, 16) AS INTEGER
DIM SHARED Mario(16, 16, 16) AS INTEGER
DIM SHARED IsSwim AS INTEGER
DIM SHARED Level(12, 500) AS INTEGER
DIM SHARED LevelOrder(128, 1) AS STRING
DIM SHARED LevelWidth AS INTEGER
DIM SHARED LevelTitle AS STRING
DIM SHARED MSprite, MX, MY, MDirection AS INTEGER
DIM SHARED XO AS INTEGER
DIM SHARED JumpVal AS SINGLE
DIM SHARED Coins, Lives AS INTEGER
DIM SHARED DeadMario AS INTEGER
DIM SHARED WalkCount AS INTEGER
DIM SHARED CanJump AS INTEGER
DIM SHARED OnFlag AS INTEGER
DIM SHARED LastLevel AS INTEGER
DIM SHARED CurrentLevel AS INTEGER
DIM SHARED PStartY, PStartX AS INTEGER

12 SCREEN 13: PALETTE: CLS
JoyEnabled = 0
LoadPal "data\smb.pal"
LoadBlocks
LoadLevelOrder
MSprite = 4
MDirection = 1
Coins = 0
Lives = 3
OnFlag = 0
LevelTitle = ""

'TITLE SCREEN
TitleScreen

NextLevel = 1
StartLevel
XO = 1
DispLevel 1
WalkCount = 4
JumpVal = 0
CanJump = 1
HoldJump = 0

kbdInit kbd 'Init keyboard routines

DO
XO = MX - 160
IF XO < 1 THEN XO = 1

SELECT CASE Level(FIX(MY / 16), FIX(MX / 16))
CASE 22, 23 'If mario is in water
	IsSwim = 1
CASE ELSE
	IsSwim = 0
END SELECT

DoPhysics
DispLevel XO
IF IsSwim = 0 THEN
	IF WalkCount < 4 THEN MSprite = MSprite + 1: WalkCount = WalkCount + 1
	IF WalkCount < 4 AND MSprite = 4 THEN MSprite = 0
ELSE
	IF WalkCount < 4 THEN MSprite = MSprite + 1: WalkCount = WalkCount + 1
	IF WalkCount < 4 AND MSprite = 12 THEN MSprite = 9
END IF
ON ERROR GOTO 3

CanJump = 0 'Determine whether or not Mario can jump
ycp = FIX(MY / 16) + 1: IF ycp > 11 THEN ycp = 11
xcp = FIX(MX / 16)
SELECT CASE Level(ycp, xcp)
	CASE 1, 2, 4, 5, 6, 12, 13, 14, 15, 16, 17, 50
	CanJump = 1
END SELECT
SELECT CASE Level(ycp, xcp + 1)
	CASE 1, 2, 4, 5, 6, 12, 13, 14, 15, 16, 17, 50
	CanJump = 1
END SELECT
IF xcp - 1 < 0 THEN xcp = 1
SELECT CASE Level(ycp, xcp - 1)
	CASE 1, 2, 4, 5, 6, 12, 13, 14, 15, 16, 17, 50
	CanJump = 1
END SELECT


IF JoyEnabled = 1 THEN
OPEN "c:\joystick.dat" FOR BINARY AS #8
IF LOF(8) = 0 THEN wrd$ = " 0,0,0": PUT #8, , wrd$
CLOSE #8
OPEN "c:\joystick.dat" FOR INPUT AS #8 'Check joystick interface.
INPUT #8, direction%
INPUT #8, button1%
INPUT #8, button2%
CLOSE #8
ELSE
direction% = 0: button1% = 0: button2% = 0
END IF

3 IF direction% = 7 OR direction% = 8 OR direction% = 6 THEN
IF button1% = 1 THEN MoveMario -6, 0 ELSE MoveMario -3, 0
MDirection = 0
StartWalkSprites
END IF

IF direction% = 3 OR direction% = 2 OR direction% = 4 THEN
IF button1% = 1 THEN MoveMario 6, 0 ELSE MoveMario 3, 0
MDirection = 1
StartWalkSprites
END IF

IF button2% = 1 THEN DoJump

'key$ = INKEY$

IF OnFlag = 2 THEN 'If done sliding down flagpole.
IF LCASE$(key$) = "a" OR LCASE$(key$) = "d" OR key$ = " " THEN key$ = ""
NextLevel = 1
StartLevel
END IF

IF kbd.esc THEN kbdEnd: GOTO 12 'escape pressed

IF kbd.left THEN 'left arrow down
	MoveMario -3, 0
	IF kbd.ctrl THEN MoveMario -3, 0 'if control pressed, run instead of walk
	MDirection = 0
	StartWalkSprites
END IF

IF kbd.right THEN 'right arrow down
	MoveMario 3, 0
	IF kbd.ctrl THEN MoveMario 3, 0 'if control pressed, run instead of walk
	MDirection = 1
	StartWalkSprites
END IF

isdown = kbd.alt
IF isdown AND HoldJump = 0 THEN DoJump 'if ALT is pressed down
IF isdown THEN HoldJump = 1 ELSE HoldJump = 0

'IF kbd.ctrl THEN

'MANUAL VERTICAL MOVEMENTS FOR DEBUG MODE:
'CASE "w" 'up
'MoveMario 0, -1

'CASE "s" 'down
'MoveMario 0, 1
'END SELECT

IF DeadMario = 1 THEN
JumpVal = -5
MoveMario 0, INT(JumpVal)

XO = MX - 160
IF XO < 1 THEN XO = 1
DispLevel XO
DO
DoPhysics
MoveMario 0, INT(JumpVal)

XO = MX - 160
IF XO < 1 THEN XO = 1
DispLevel XO
dummy$ = INKEY$
LOOP UNTIL MY >= 170
Lives = Lives - 1
NextLevel = 2
StartLevel
END IF

LOOP

SUB BreakBlock (bky AS INTEGER, bkx AS INTEGER)
Level(bky, bkx) = 0
END SUB

SUB CtrText (txt AS STRING, y)
xlc = 20 - (LEN(txt) / 2)
IF xlc < 1 THEN xlc = 1: txt = LEFT$(MID$(txt, FIX(LEN(txt) / 2) - 20), 40)
LOCATE y, xlc: PRINT txt;
END SUB

SUB DispLevel (XOffset AS INTEGER)
IF DeadMario = 1 THEN MSprite = 5

IF DisplayMode = 1 OR DisplayMode = 2 THEN stp = 2 ELSE stp = 1
IF DisplayMode <> 1 THEN Interlacing = 0

IF DisplayMode = 1 THEN
IF Interlacing = 0 THEN Interlacing = 1 ELSE Interlacing = 0
END IF

LOCATE 1, 1
PRINT "  MarioQB    " + LEFT$("Coins:" + STR$(Coins) + "              ", 16) + "Lives:" + STR$(Lives) + "  "

IF IsSwim = 1 THEN IF WalkCount < 4 THEN MSprite = WalkCount + 8 ELSE MSprite = 9

'XOff = FIX(XOffset / 16)
XOff = FIX(XO / 16)
XOff = (XO - XOff)
FixOff = INT(XO / 16)
'FixOff = 0
DIM TempMario(320, 200) AS STRING * 1

stx = MX - SOff
sty = MY + 8
sbx = FIX(MX / 16) - 1: ebx = FIX(MX / 16) + 1
sby = FIX(MY / 16) - 1: eby = FIX(MY / 16) + 1

FOR realy = 0 TO 15
FOR realx = 0 TO 15
	IF MDirection = 0 THEN usex = 15 - realx ELSE usex = realx
	colr = Mario(MSprite, usex, realy)
	'IF colr <> 0 THEN
	putx = stx + realx - XOff - FixOff
	puty = sty + realy - 8
	IF OnFlag = 1 THEN putx = putx + 16
	IF putx > 320 THEN putx = 320
	IF putx < 0 THEN putx = 0
	IF puty > 200 THEN puty = 200
	IF puty < 0 THEN puty = 0
   
	TempMario(putx, puty) = CHR$(colr)
NEXT realx
NEXT realy


'ON ERROR GOTO 1
startx = FIX(XO / 16)
IF startx < 0 THEN startx = 0
endx = startx + 20
IF endx > LevelWidth THEN startx = LevelWidth - 20: endx = LevelWidth
IF startx < 0 THEN startx = 0

FOR sy = 0 TO 11
FOR sx = startx TO endx
	'PRINT sx; " "
	blockindex = Level(sy, sx)
    
	'PRINT blockindex;
	'END
	IF blockindex = 0 THEN dontdraw = 1 ELSE dontdraw = 0
IF sx >= sbx AND sx <= ebx AND sy >= sby AND sy <= eby THEN
	FOR realy = 0 + Interlacing TO 15 STEP stp
	FOR realx = 0 TO 15
	'IF MX = sx AND MY = sy THEN
	'colr = Mario(MSprite, realx, realy)
	'IF colr = 0 THEN
	'IF dontdraw = 1 THEN colr = 254 ELSE colr = Blocks(blockindex, realx, realy)
	'END IF
	'ELSE
	IF dontdraw = 1 THEN colr = 254 ELSE IF blockindex = 50 THEN colr = 254 ELSE colr = Blocks(blockindex, realx, realy)
    'END IF
	'IF colr = 0 THEN colr = 254
	drx = (sx * 16) + realx - XOff - FixOff
	dry = (sy * 16) + realy
	IF drx < 0 THEN drx = 0
	IF drx > 320 THEN drx = 320
	IF dry < 0 THEN dry = 0
	IF dry > 320 THEN dry = 320
	IF TempMario(drx, dry) <> CHR$(0) THEN colr = ASC(TempMario(drx, dry))
	'IF dontdraw = 1 AND colr = 0 THEN colr = 254
	IF colr = 0 THEN colr = 254
	IF DisplayMode < 2 THEN
		PSET (drx, dry + 8), colr
	ELSE
		newx = (drx / 2) + 80
		newy = (dry / 2) + 50
		PSET (newx, newy), colr
	END IF
	'DrawScreen((sx * 16) + realx, (sy * 16) + realy + 8) = CHR$(colr)
	NEXT realx
	NEXT realy
ELSE

IF (MX <> sx OR MY <> sy) THEN
	   
	SELECT CASE blockindex
	CASE 0 'IF BLOCK IS EMPTY
		colbg = 254
	CASE 22 'IF BLOCK IS WATER
		colbg = 128
	CASE ELSE
		GOTO 16
	END SELECT
	    
	    
	IF DisplayMode < 2 THEN
		LINE ((sx * 16) - XOff - FixOff, (sy * 16) + 8)-((sx * 16) + 15 - XOff - FixOff, (sy * 16) + 23), colbg, BF
	ELSE
		LINE ((((sx * 16) - XOff - FixOff) / 2) + 80, ((sy * 16) / 2) + 50)-((((sx * 16) + 15 - XOff - FixOff) / 2) + 80, (((sy * 16) + 14) / 2) + 50), colbg, BF
	END IF
    
	'FOR ey = 0 TO 15
	'FOR ex = 0 TO 15
	'DrawScreen((sx * 16) + realx, (sy * 16) + realy + 8) = CHR$(254)
	'NEXT ex
	'NEXT ey
ELSE
	'START STANDARD DRAWING ROUTINE HERE
16 FOR realy = 0 + Interlacing TO 15 STEP stp
	FOR realx = 0 TO 15
	'IF MX = sx AND MY = sy THEN
	'colr = Mario(MSprite, realx, realy)
	'IF colr = 0 THEN
	'IF dontdraw = 1 THEN colr = 254 ELSE colr = Blocks(blockindex, realx, realy)
	'END IF
	'ELSE
	IF dontdraw = 1 THEN colr = 254 ELSE IF blockindex = 50 THEN colr = 0 ELSE colr = Blocks(blockindex, realx, realy)
    'END IF
	IF colr = 0 THEN colr = 254
   
	IF DisplayMode < 2 THEN
		PSET ((sx * 16) + realx - XOff - FixOff, (sy * 16) + realy + 8), colr
	ELSE
		newx = (((sx * 16) + realx - XOff - FixOff) / 2) + 80
		newy = (((sy * 16) + realy) / 2) + 50
		PSET (newx, newy), colr
		 
		'LINE ((sx * 16) + realx - XOff - FixOff, (sy * 16) + realy + 8)-((sx * 16) + realx - XOff - FixOff, (sy * 16) + realy + 9), colr
	END IF
	'DrawScreen((sx * 16) + realx, (sy * 16) + realy + 8) = CHR$(colr)
	NEXT realx
	NEXT realy
	END IF
END IF
NEXT sx
NEXT sy
EXIT SUB 'STOP HERE

'Draw mario into screen
FOR realy = 0 + Interlacing TO 15 STEP stp
FOR realx = 0 TO 15
	colr = Mario(MSprite, realx, realy)
	IF colr <> 0 AND DisplayMode < 2 THEN PSET (stx + realx - FixOff, sty + realy), colr'DrawScreen(stx + realx, sty + realy) = CHR$(colr)
	IF colr <> 0 AND DisplayMode = 2 THEN PSET (((stx + realx - FixOff) / 2) + 80, ((sty + realy) / 2) + 46), colr'LINE (stx + realx - FixOff, sty + realy)-(stx + realx - FixOff, sty + realy + 1), colr
NEXT realx
NEXT realy
'finished drawing mario
EXIT SUB

FOR yy = 1 TO 200 STEP 1
FOR xx = 1 TO 320 STEP 1
'PSET (xx, yy), ASC(DrawScreen(xx, yy))
'LINE (xx, yy)-(xx + 1, yy + 1), ASC(DrawScreen(xx, yy)), BF
NEXT xx
NEXT yy
END SUB

SUB DoJump
IF IsSwim = 0 AND CanJump = 1 THEN
CanJump = 0
JumpVal = -9
ELSE IF IsSwim = 1 THEN JumpVal = -3: StartWalkSprites
END IF
END SUB

SUB DoPhysics
IF OnFlag = 1 THEN MoveMario 0, 1: MSprite = 7: EXIT SUB

IF IsSwim = 1 AND DeadMario = 0 THEN 'If mario is in water.
	CanJump = 0
	MoveMario 0, INT(JumpVal)
	JumpVal = JumpVal + .25
	IF JumpVal > 2 THEN JumpVal = 2
ELSE 'Perform normal physics
	IF JumpVal = 0 THEN MoveMario 0, 8 ELSE MoveMario 0, INT(JumpVal)
	'IF JumpVal = 0 THEN CanJump = 1
	JumpVal = JumpVal + .75
	IF JumpVal > 8 THEN JumpVal = 8
END IF
END SUB

SUB GrabCoin (ybl, xbl)
Level(ybl, xbl) = 0
Coins = Coins + 1
END SUB

FUNCTION InBounds (checkx, checky)
IF checkx > 0 AND checkx < 161 AND checky > 0 AND checky < 101 THEN InBounds = 1 ELSE InBounds = 0
END FUNCTION

FUNCTION JoyButton1
'ON ERROR GOTO 5
OPEN "c:\joystick.dat" FOR BINARY AS #8
IF LOF(8) = 0 THEN wrd$ = " 0,0,0": PUT #8, , wrd$
CLOSE #8
OPEN "c:\joystick.dat" FOR INPUT AS #8 'Check joystick interface.
IF EOF(8) THEN GOTO 15
INPUT #8, direction%
IF EOF(8) THEN GOTO 15
INPUT #8, button1%
IF EOF(8) THEN GOTO 15
INPUT #8, button2%
15 CLOSE #8
JoyButton1 = button1%
'OPEN "c:\joystick.dat" FOR OUTPUT AS #10
'PRINT #10, STR$(direction%) + ",0," + STR$(button2%)
'CLOSE #10
EXIT FUNCTION
5 JoyButton1 = 0
END FUNCTION

FUNCTION JoyButton2
'ON ERROR GOTO 6
OPEN "c:\joystick.dat" FOR BINARY AS #8
IF LOF(8) = 0 THEN wrd$ = " 0,0,0": PUT #8, , wrd$
CLOSE #8
OPEN "c:\joystick.dat" FOR INPUT AS #8 'Check joystick interface.
INPUT #8, direction%
INPUT #8, button1%
INPUT #8, button2%
CLOSE #8
JoyButton2 = button2%
'OPEN "c:\joystick.dat" FOR OUTPUT AS #10
'PRINT #10, STR$(direction%) + "," + STR$(button1%) + ",0"
'CLOSE #10

EXIT FUNCTION
6 JoyButton2 = 0
END FUNCTION

FUNCTION JoyDirection
'ON ERROR GOTO 8
OPEN "c:\joystick.dat" FOR BINARY AS #8
IF LOF(8) = 0 THEN wrd$ = " 0,0,0": PUT #8, , wrd$
CLOSE #8
OPEN "c:\joystick.dat" FOR INPUT AS #8 'Check joystick interface.
INPUT #8, direction%
INPUT #8, button1%
INPUT #8, button2%
CLOSE #8
JoyDirection = direction%
'OPEN "c:\joystick.dat" FOR OUTPUT AS #10
'PRINT #10, " 0," + STR$(button1%) + "," + STR$(button2%)
'CLOSE #10
EXIT FUNCTION
8 JoyDirection = 0
END FUNCTION

SUB Killed
MSprite = 5
WalkCount = 3
DeadMario = 1
MY = 175
NextLevel = 2
END SUB

SUB LoadBlocks
FOR n = 1 TO 24
fa$ = "data\block" + RIGHT$("00" + MID$(STR$(n), 2), 2) + ".raw"
OPEN fa$ FOR BINARY AS #1
gi$ = SPACE$(256): GET #1, , gi$: gp = 1
FOR y = 0 TO 15
FOR x = 0 TO 15
'PSET (x, y), ASC(MID$(gi$, gp, 1))
Blocks(n, x, y) = ASC(MID$(gi$, gp, 1))
gp = gp + 1
NEXT x
NEXT y
CLOSE #1
NEXT n

FOR n = 0 TO 11
fa$ = "data\mario" + RIGHT$("00" + MID$(STR$(n), 2), 2) + ".raw"

OPEN fa$ FOR BINARY AS #1
gi$ = SPACE$(256): GET #1, , gi$: gp = 1
FOR y = 0 TO 15
FOR x = 0 TO 15
'PSET (x, y), ASC(MID$(gi$, gp, 1))
Mario(n, x, y) = ASC(MID$(gi$, gp, 1))
gp = gp + 1
NEXT x
NEXT y
CLOSE #1

NEXT n

END SUB

SUB LoadLevel (levelfile AS STRING)
LevelWidth = 1
DIM nbi AS INTEGER

OPEN "data\" + levelfile FOR INPUT AS #3
INPUT #3, LevelWidth
FOR ly = 0 TO 11
FOR lx = 0 TO LevelWidth - 1
INPUT #3, nbi
IF nbi = -1 THEN
PStartY = ly
PStartX = lx
Level(ly, lx) = 0
MX = lx * 16
MY = ly * 16
ELSE
Level(ly, lx) = nbi
END IF
NEXT lx
NEXT ly

CLOSE #3
END SUB

SUB LoadLevelOrder
OPEN "data\levels.dat" FOR BINARY AS #11: CLOSE #11
OPEN "data\levels.dat" FOR INPUT AS #11
lev = 0
DO
INPUT #11, fin$
LINE INPUT #11, nm$
LevelOrder(lev, 0) = fin$
LevelOrder(lev, 1) = nm$
lev = lev + 1
LOOP UNTIL EOF(11)
LastLevel = lev - 1
CLOSE #11
END SUB

SUB LoadPal (filename AS STRING)
OPEN filename FOR BINARY AS #2
s$ = SPACE$(28): GET #2, , s$
FOR n = 1 TO 255
A$ = SPACE$(1)
B$ = SPACE$(1)
c$ = SPACE$(1)
d$ = SPACE$(1)
GET #2, , A$
GET #2, , B$
GET #2, , c$
GET #2, , d$
rat = (255 / 63)
r& = ASC(A$) / rat
g& = ASC(B$) / rat
B& = ASC(c$) / rat
PALETTE n, r& + 256 * g& + 65536 * B&
NEXT n
CLOSE #2
PALETTE 254, 20 + 256 * 20 + 65536 * 63
PALETTE 255, 63 + 256 * 63 + 65536 * 63
COLOR 255
END SUB

SUB MoveMario (MoveX AS INTEGER, MoveY AS INTEGER)
IF OnFlag = 1 THEN MoveX = 0: MoveY = 2
IF OnFlag = 2 THEN EXIT SUB
currx = MX
curry = MY
blockx = FIX(currx / 16)
blocky = FIX(curry / 16)
reachx = currx - (blockx * 16)
reachy = curry - (blocky * 16)
IF MoveX < 0 THEN dirx = -1 'Moving left
IF MoveX > 0 THEN dirx = 1 'Moving right
IF MoveY < 0 THEN diry = -1 'Moving up
IF MoveY > 0 THEN diry = 1 'Moving down
absolutex = ABS(MoveX) 'Get absolute X movemnt
absolutey = ABS(MoveY) 'Get absolute Y movement
IF MY < 1 THEN MY = 1

'BigMario = 1
IF DeadMario = 1 THEN MoveX = 0

by = blocky
bx = blockx
IF FIX(MX / 16) <> MX / 16 AND MoveX > 0 THEN bx = bx + 1
'IF FIX(MX / 16) <> MX / 16 AND MoveX < 0 THEN bx = bx - 1
IF FIX(MY / 16) <> MY / 16 THEN by = by + 1
IF by < 1 THEN by = 1
IF FIX(MY / 16) + 1 >= 12 THEN MY = 175: Killed: EXIT SUB

IF OnFlag = 1 THEN
bux = FIX(MX / 16) + 1
buy = FIX(MY / 16)
IF buy > 11 THEN buy = 11
SELECT CASE Level(buy + 1, bux)
CASE 2
OnFlag = 2
END SELECT
END IF

'CHECK IF MARIO IS EXACTLY ON HORIZONTAL BLOCK
IF yousuck = 1 AND FIX(MX / 16) = MX / 16 AND MoveX = 0 THEN
	IF MDirection = 1 THEN lil = 1
	IF MDirection = 2 THEN lil = -1
	IF MoveY > 0 THEN lol = 1
	IF MoveY < 0 THEN lol = -1

	DoMove = 1
	IF blocky < 1 THEN blocky = 1
	IF blocky > 11 THEN blocky = 11
	SELECT CASE Level(blocky + lol, bx)
	CASE 1, 2, 4, 5, 6, 14, 15, 16, 17, 50
	BlockHit = Level(blocky + lol, bx)
	JumpVal = 0
	MY = FIX(MY / 16) * 16
	'IF MoveX = 0 AND MoveY <> 0 THEN DoMove = 0
	DoMove = 0

	CASE 12 'Question mark box
	JumpVal = 0
	MY = FIX(MY / 16) * 16
	'IF MoveX = 0 AND MoveY <> 0 THEN DoMove = 0
	DoMove = 0

	CASE 13 'Can break block if big
	JumpVal = 0
	MY = FIX(MY / 16) * 16
	'IF MoveX = 0 AND MoveY <> 0 THEN DoMove = 0
	'IF BigMario = 1 THEN BreakBlock blocky + 1, bx
	DoMove = 0

	CASE 18, 19, 20
	JumpVal = 0
	MX = bx * 16
	MY = (blocky + 1) * 16
	BlockHit = 18
	DoMove = 0

	CASE 7
	grabit = 1

	CASE ELSE
	'IF (MY + MoveY) / 16 > FIX((MY + MoveY) / 16) THEN
	'MY = FIX(MY / 16)
	'ELSE
	'IF MY + MoveY + 16 < (11 * 16) THEN domove = 1
	'END IF
	END SELECT
  
	IF DoMove = 0 THEN
	IF OnFlag = 1 OR OnFlag = 2 THEN
	NextLevel = 1
	StartLevel
	END IF
	END IF
	'GOTO 11
END IF


DoMove = 1
IF MoveX < 0 THEN 'If moving left
	IF blockx < 1 THEN blockx = 1
	SELECT CASE Level(by, blockx)'Check next horizontal block
	CASE 1, 2, 4, 5, 6, 12, 13, 14, 15, 16, 17, 50 'If any of these block types
	BlockHitX = Level(blocky, blockx)
	DoMove = 0

	CASE 7
	GrabCoin by, blockx
    
	CASE ELSE 'If any other block type
	'IF MX + MoveX > 0 THEN MX = MX + MoveX
	END SELECT

ELSE 'If moving right
	SELECT CASE Level(by, blockx + 1)
	CASE 1, 2, 4, 5, 6, 12, 13, 14, 15, 16, 17, 50
	BlockHitX = Level(by, blockx + 1)
	DoMove = 0

	CASE 7
	GrabCoin by, blockx + 1

	CASE ELSE
	END SELECT
END IF
IF DoMove = 1 AND MX + MoveX + 16 < (LevelWidth * 16) THEN MX = MX + MoveX

'VERTICAL MOVEMENT:
grabit = 0
DoMove = 1
IF MoveY < 0 THEN 'If moving up
	IF blocky < 1 THEN blocky = 1
	SELECT CASE Level(blocky - 1, bx)'Check next vertical block
	CASE 1, 2, 4, 5, 6, 14, 15, 16, 17, 50'If any of these block types
	BlockHit = Level(blocky + 1, bx)
	JumpVal = 0 'If object hit during jump, stop upward movement.
	MY = FIX(MY / 16) * 16
	DoMove = 0

	CASE 12 'Question mark box
	JumpVal = 0
	MY = FIX(MY / 16) * 16
	DoMove = 0

	CASE 13 'Can break block if big
	JumpVal = 0
	MY = FIX(MY / 16) * 16
	DoMove = 0
	'IF BigMario = 1 THEN BreakBlock blocky - 1, bx

	CASE 18, 19, 20
	JumpVal = 0
	MX = bx * 16
	MY = (blocky + 1) * 16
	BlockHit = 18
	DoMove = 0

	CASE 7
	grabit = 1

	CASE ELSE 'If any other block type
	'IF MY + MoveY > 0 THEN MY = MY + MoveY
	END SELECT
    
	IF blocky > 11 THEN blocky = 11
	SELECT CASE Level(blocky - 1, bx + 1)
	CASE 1, 2, 4, 5, 6
	JumpVal = 0
	MY = FIX(MY / 16) * 16
	DoMove = 0
   
	CASE 12 'Question mark box
	JumpVal = 0
	MY = FIX(MY / 16) * 16
	DoMove = 0

	CASE 13 'Can break block if big
	JumpVal = 0
	MY = FIX(MY / 16) * 16
	DoMove = 0

	CASE 18, 19, 20
	JumpVal = 0
	MX = (bx + 1) * 16
	MY = (blocky - 1) * 16
	BlockHit = 18
	DoMove = 0

	CASE 7
	grabit = 1

	CASE ELSE
	'IF (MY + MoveY) / 16 > FIX((MY + MoveY) / 16) THEN
	'MY = FIX(MY / 16)
	'ELSE
	'IF MY + MoveY + 16 < (11 * 16) THEN domove = 1
	'END IF
	END SELECT

ELSE 'If moving down
	IF blocky > 11 THEN blocky = 11
	
	SELECT CASE Level(blocky + 1, bx)'Check next vertical block
	CASE 1, 2, 4, 5, 6, 14, 15, 16, 17, 50'If any of these block types
	BlockHit = Level(blocky + 1, bx)
	JumpVal = 0 'If object hit during jump, stop upward movement.
	MY = FIX(MY / 16) * 16
	DoMove = 0

	CASE 12 'Question mark box
	JumpVal = 0
	MY = FIX(MY / 16) * 16
	DoMove = 0

	CASE 13 'Can break block if big
	JumpVal = 0
	MY = FIX(MY / 16) * 16
	DoMove = 0
	'IF BigMario = 1 THEN BreakBlock blocky + 1, bx

	CASE 18, 19, 20
	JumpVal = 0
	MX = bx * 16
	MY = (blocky + 1) * 16
	BlockHit = 18

	CASE 7
	grabit = 1

	CASE ELSE 'If any other block type
	'IF MY + MoveY > 0 THEN MY = MY + MoveY
	END SELECT
   
	'UN-REM THIS
	IF blocky > 11 THEN blocky = 11
	SELECT CASE Level(blocky + 1, bx + 1)
	CASE 1, 2, 4, 5, 6, 14, 15, 16, 17, 50
	BlockHit = Level(blocky + 1, bx)
	JumpVal = 0
	MY = FIX(MY / 16) * 16
	DoMove = 0
	
	CASE 12 'Question mark box
	JumpVal = 0
	MY = FIX(MY / 16) * 16
	DoMove = 0
	
	CASE 13 'Can break block if big
	JumpVal = 0
	MY = FIX(MY / 16) * 16
	DoMove = 0
	'IF BigMario = 1 THEN BreakBlock blocky + 1, bx + 1
	
	CASE 18, 19, 20
	JumpVal = 0
	MX = bx * 16
	MY = (blocky + 1) * 16
	BlockHit = 18
	
	CASE 7
	grabit = 1
	
	CASE ELSE
	'IF (MY + MoveY) / 16 > FIX((MY + MoveY) / 16) THEN
	'MY = FIX(MY / 16)
	'ELSE
	'IF MY + MoveY + 16 < (11 * 16) THEN domove = 1
	'END IF
	END SELECT
END IF

11
IF DoMove = 1 THEN MY = MY + MoveY

IF BlockHitX = 2 AND OnFlag = 1 THEN OnFlag = 2

SELECT CASE BlockHit
CASE 2
IF OnFlag = 1 THEN 'Done sliding down flag pole.
OnFlag = 2
END IF

CASE 12

CASE 18
OnFlag = 1

CASE 12


END SELECT

END SUB

SUB OptionsMenu (mu)
wi = 340
ht = 100
scale = .75
FOR moveup = mu TO mu - 125 STEP -5
ofx = 160 - ((wi * scale) / 2)
ofy = 100 - ((ht * scale) / 2)
FOR ty = 1 TO ht
FOR tx = 1 TO wi
	LINE ((tx * scale) - scale + ofx, (ty * scale) - scale + ofy - moveup)-((tx * scale) + ofx, (ty * scale) + ofy - moveup), ASC(TempGfx(tx, ty)), BF
NEXT tx
NEXT ty
LINE (0, 0)-(ofx, 200), 0, BF
LINE (320 - ofx, 0)-(320, 200), 0, BF
LINE (0, 0)-(320, ofy - moveup), 0, BF
LINE (0, 200 - ofy - moveup)-(320, 200), 0, BF
NEXT moveup

CtrText "       ", 3

selcur = 1
DO
keyb$ = INKEY$
jd = JoyDirection: jb1 = JoyButton1: jb2 = JoyButton2
movecur = 0
SELECT CASE keyb$
CASE CHR$(0) + CHR$(80) 'Keyboard down arrow
	movecur = 1
CASE CHR$(0) + CHR$(72) 'Keyboard up arrow
	movecur = 2
CASE CHR$(13) 'Keyboard ENTER
	movecur = -1
END SELECT

SELECT CASE jd
CASE 4, 5, 6 'Joystick down
	movecur = 1

CASE 1, 2, 8 'Joystick up
	movecur = 2
END SELECT

IF jb1 OR jb2 THEN movecur = -1

IF movecur = 1 THEN selcur = selcur + 1: IF selcur = 6 THEN selcur = 5
IF movecur = 2 THEN selcur = selcur - 1: IF selcur = 0 THEN selcur = 1
IF movecur = -1 THEN 'If an option is chosen
SELECT CASE selcur
CASE 1 'Frameskip is chosen

CASE 2 'Graphics chosen
DisplayMode = DisplayMode + 1
IF DisplayMode = 3 THEN DisplayMode = 0

CASE 3 'Joystick is chosen
IF JoyEnabled = 1 THEN JoyEnabled = 2 ELSE JoyEnabled = 1

CASE 4 'Joystick test is chosen
CtrText "       ", 3
CtrText SPACE$(80), 6
CtrText SPACE$(80), 8
CtrText SPACE$(80), 10
CtrText SPACE$(80), 12
CtrText SPACE$(80), 16
TestJoystick
CtrText "OPTIONS", 3

CASE 5 'Main menu is chosen
EXIT DO
END SELECT
END IF

IF JoyEnabled = 1 THEN isjoy$ = "ENABLED   " ELSE isjoy$ = "DISABLED  "

SELECT CASE DisplayMode
CASE 0
	isgraphics$ = "NORMAL    "
CASE 1
	isgraphics$ = "INTERLACED"
CASE 2
	isgraphics$ = "HALF-RES  "
END SELECT

SELECT CASE selcur
CASE 1
	CtrText CHR$(16) + " FRAMESKIP: DISABLED ", 7
	CtrText "  GRAPHICS: " + isgraphics$, 8
	CtrText "  JOYSTICK: " + isjoy$, 9
	CtrText "  TEST JOYSTICK       ", 10
	CtrText "  MAIN MENU           ", 12
	CtrText "FRAMESKIP NOT AVAILABLE IN v0.8a", 15

CASE 2
	CtrText "  FRAMESKIP: DISABLED ", 7
	CtrText CHR$(16) + " GRAPHICS: " + isgraphics$, 8
	CtrText "  JOYSTICK: " + isjoy$, 9
	CtrText "  TEST JOYSTICK       ", 10
	CtrText "  MAIN MENU           ", 12
	CtrText "                                ", 15

CASE 3
	CtrText "  FRAMESKIP: DISABLED ", 7
	CtrText "  GRAPHICS: " + isgraphics$, 8
	CtrText CHR$(16) + " JOYSTICK: " + isjoy$, 9
	CtrText "  TEST JOYSTICK       ", 10
	CtrText "  MAIN MENU           ", 12
	CtrText "                                ", 15

CASE 4
	CtrText "  FRAMESKIP: DISABLED ", 7
	CtrText "  GRAPHICS: " + isgraphics$, 8
	CtrText "  JOYSTICK: " + isjoy$, 9
	CtrText CHR$(16) + " TEST JOYSTICK       ", 10
	CtrText "  MAIN MENU           ", 12
	CtrText "                                ", 15

CASE 5
	CtrText "  FRAMESKIP: DISABLED ", 7
	CtrText "  GRAPHICS: " + isgraphics$, 8
	CtrText "  JOYSTICK: " + isjoy$, 9
	CtrText "  TEST JOYSTICK       ", 10
	CtrText CHR$(16) + " MAIN MENU           ", 12
	CtrText "                                ", 15
END SELECT
LOOP

mu = moveup
FOR moveup = mu TO mu + 125 STEP 5
ofx = 160 - ((wi * scale) / 2)
ofy = 100 - ((ht * scale) / 2)
FOR ty = 1 TO ht
FOR tx = 1 TO wi
	LINE ((tx * scale) - scale + ofx, (ty * scale) - scale + ofy - moveup)-((tx * scale) + ofx, (ty * scale) + ofy - moveup), ASC(TempGfx(tx, ty)), BF
NEXT tx
NEXT ty
LINE (0, 0)-(ofx, 200), 0, BF
LINE (320 - ofx, 0)-(320, 200), 0, BF
LINE (0, 0)-(320, ofy - moveup), 0, BF
LINE (0, 200 - ofy - moveup)-(320, 200), 0, BF
NEXT moveup
END SUB

SUB StartLevel
QuitGame = 0
XO = 1

JumpVal = 0
DeadMario = 0
WalkCount = 4
BigMario = 0
MDirection = 1
MSprite = 4
OnFlag = 0
MX = PStartX * 16
MY = PStartY * 16


IF NextLevel = 2 THEN
FOR nas = 0 TO 128
	IF LevelOrder(nas, 1) = LevelTitle THEN
		LevelTitle = LevelOrder(nas, 1)
		LevelFN$ = LevelOrder(nas, 0)
	END IF
NEXT nas
END IF

IF NextLevel = 1 THEN
IF CurrentLevel = -1 THEN
LevelTitle = LevelOrder(0, 1)
LevelFN$ = LevelOrder(0, 0)
Lives = 3
Coins = 0
CurrentLevel = 0
QuitGame = 0
ELSE

IF CurrentLevel + 1 <= LastLevel THEN
LevelTitle = LevelOrder(CurrentLevel + 1, 1)
LevelFN$ = LevelOrder(CurrentLevel + 1, 0)
CurrentLevel = CurrentLevel + 1
QuitGame = 0
ELSE
LevelTitle = "END OF GAME"
QuitGame = 1
END IF

END IF
END IF

CLS : COLOR 255
IF Lives = -1 THEN ln$ = "" ELSE ln$ = LevelTitle
LOCATE 9, 20 - (LEN(ln$) / 2): PRINT ln$

IF QuitGame <> 1 THEN
	IF Lives = -1 THEN ln$ = "GAME OVER" ELSE ln$ = "MARIO x" + STR$(Lives)
	LOCATE 11, 20 - (LEN(ln$) / 2): PRINT ln$
ELSE
	LOCATE 11, 20 - (LEN(lt2$) / 2): PRINT lt2$
END IF

t! = TIMER
DO: dummy$ = INKEY$: LOOP UNTIL TIMER - t! > 4 'OR JoyButton1 = 1 OR JoyButton2 = 1 OR t! > TIMER
IF Lives = -1 OR QuitGame = 1 THEN kbdEnd: NextLevel = 1: LevelTitle = "": TitleScreen: EXIT SUB

IF NextLevel = 1 OR NextLevel = 2 THEN LoadLevel LevelFN$
IF NextLevel = 2 THEN Coins = 0
NextLevel = 0
DO: LOOP UNTIL INKEY$ = ""
END SUB

SUB StartWalkSprites
IF WalkCount < 3 THEN EXIT SUB
MSprite = 0
WalkCount = 0
END SUB

SUB TestJoystick
LINE (0, 0)-(320, 16 * 8), 0, BF
PALETTE 253, 63
LINE (80, 69)-(130, 79), 255, B
LINE (100, 54)-(110, 94), 255, B
CtrText "JOYSTICK INPUT TEST", 3
CtrText "PRESS ENTER WHEN FINISHED", 15

DO

IF JoyButton1 THEN
	COLOR 253
	LOCATE 10, 22: PRINT "1"
	CIRCLE (171, 75), 10, 253
ELSE
	COLOR 255
	LOCATE 10, 22: PRINT "1"
	CIRCLE (171, 75), 10, 255
END IF

IF JoyButton2 THEN
	COLOR 253
	LOCATE 10, 25: PRINT "2"
	CIRCLE (195, 75), 10, 253
ELSE
	COLOR 255
	LOCATE 10, 25: PRINT "2"
	CIRCLE (195, 75), 10, 255
END IF

SELECT CASE JoyDirection
CASE 0 'none
LINE (81, 70)-(129, 78), 0, BF
LINE (101, 55)-(109, 93), 0, BF

CASE 1 'up
LINE (81, 70)-(129, 78), 0, BF
LINE (101, 55)-(109, 69), 253, BF
LINE (101, 71)-(109, 93), 0, BF

CASE 5 'down
LINE (81, 70)-(129, 78), 0, BF
LINE (101, 80)-(109, 93), 253, BF
LINE (101, 55)-(109, 79), 0, BF

CASE 7 'left
LINE (81, 70)-(100, 78), 253, BF
LINE (101, 70)-(129, 78), 0, BF
LINE (101, 55)-(109, 93), 0, BF

CASE 3 'right
LINE (81, 70)-(109, 78), 0, BF
LINE (110, 70)-(129, 78), 253, BF
LINE (101, 55)-(109, 93), 0, BF

CASE 8 'upleft
LINE (101, 71)-(109, 93), 0, BF
LINE (102, 70)-(129, 78), 0, BF
LINE (81, 70)-(100, 78), 253, BF
LINE (101, 55)-(109, 69), 253, BF

CASE 2 'upright
LINE (81, 70)-(109, 78), 0, BF
LINE (101, 71)-(109, 93), 0, BF
LINE (110, 70)-(129, 78), 253, BF
LINE (101, 55)-(109, 69), 253, BF

CASE 6 'downleft
LINE (101, 55)-(109, 79), 0, BF
LINE (102, 70)-(129, 78), 0, BF
LINE (81, 70)-(100, 78), 253, BF
LINE (101, 80)-(109, 93), 253, BF

CASE 4 'downright
LINE (101, 55)-(109, 79), 0, BF
LINE (81, 70)-(109, 78), 0, BF
LINE (110, 70)-(129, 78), 253, BF
LINE (101, 80)-(109, 93), 253, BF
END SELECT

IF INKEY$ = CHR$(13) THEN LINE (0, 0)-(320, 8 * 16), 0, BF: EXIT SUB
LOOP
END SUB

SUB TitleScreen
COLOR 255: PALETTE 255, 0: CLS
CtrText "SUPER MARIO BROTHERS (c)1984 NINTENDO", 4
CtrText "HALF-EATEN SOFTWARE IS IN NO WAY", 6
CtrText "AFFILIATED WITH NINTENDO OR ANY OF", 7
CtrText "THEIR ASSOCIATED COMPANIES.", 8
CtrText "MarioQB v0.5 alpha TEST RELEASE", 21
CtrText "(c)2005 Half-Eaten Software", 22

FOR palfade& = 0 TO 63 STEP 1
t! = TIMER
PALETTE 255, palfade& + 256 * palfade& + 65536 * palfade&
'dummy$ = ""
DO: LOOP UNTIL TIMER > t! OR t! > TIMER
IF INKEY$ <> "" OR JoyButton1 = 1 OR JoyButton2 = 1 THEN PALETTE 255, 63 + 256 * 63 + 65536 * 63: EXIT FOR
NEXT palfade&
DO: LOOP UNTIL JoyButton1 = 0 AND JoyButton2 = 0

t! = TIMER
DO: dummy$ = INKEY$
IF JoyButton1 = 1 OR JoyButton2 = 1 THEN EXIT DO
LOOP UNTIL TIMER - t! > 3 OR t! > TIMER OR dummy$ <> ""
DO: LOOP UNTIL JoyButton1 = 0 AND JoyButton2 = 0

'Text palette fade
FOR palfade& = 63 TO 0 STEP -1
t! = TIMER
PALETTE 255, palfade& + 256 * palfade& + 65536 * palfade&
DO: LOOP UNTIL TIMER > t! OR t! > TIMER
IF INKEY$ <> "" OR JoyButton1 = 1 OR JoyButton2 = 1 THEN PALETTE 255, 0: EXIT FOR
NEXT palfade&
DO: LOOP UNTIL JoyButton1 = 0 AND JoyButton2 = 0
CLS : PALETTE 255, 63 + 256 * 63 + 65536 * 63

OPEN "data\title1.raw" FOR BINARY AS #9
wi = 340: ht = 100
FOR ty = 1 TO ht
gli$ = SPACE$(wi): GET #9, , gli$
FOR tx = 1 TO wi
	TempGfx(tx, ty) = MID$(gli$, tx, 1)
NEXT tx
NEXT ty
CLOSE #9

DO: LOOP UNTIL JoyButton1 = 0 AND JoyButton2 = 0

'Display
pressed = 0
moveup = -50
FOR scale = 5 TO .75 STEP -.05
ofx = 160 - ((wi * scale) / 2)
ofy = 100 - ((ht * scale) / 2)
FOR ty = 1 TO ht
FOR tx = 1 TO wi
	LINE ((tx * scale) - scale + ofx, (ty * scale) - scale + ofy - moveup)-((tx * scale) + ofx, (ty * scale) + ofy - moveup), ASC(TempGfx(tx, ty)), BF
	'PSET ((tx * scale) - scale + ofx, (ty * scale)), ASC(TempGfx(tx, ty))
NEXT tx
NEXT ty
LINE (0, 0)-(ofx, 200), 0, BF
LINE (320 - ofx, 0)-(320, 200), 0, BF
LINE (0, 0)-(320, ofy - moveup), 0, BF
LINE (0, 215 - ofy - moveup)-(320, 200), 0, BF
moveup = moveup + 1.3
dummy$ = INKEY$

'THIS CODE ALLOWS USER TO SPEED UP TITLE GRAPHICS IF
'JOYSTICK BUTTON IS HIT OR A KEY IS HIT
'IF JoyButton1 = 1 OR JoyButton2 = 1 OR dummy$ <> "" THEN
'pressed = 1
'END IF

IF pressed = 1 THEN scale = scale - .25: moveup = moveup + 6.5
NEXT scale
LINE (0, 200 - ofy - moveup + 1.3)-(320, 200), 0, BF

DO: LOOP UNTIL JoyButton1 = 0 AND JoyButton2 = 0

selcur = 1
DO
SELECT CASE selcur
CASE 1
CtrText CHR$(16) + " START GAME", 15
CtrText "  OPTIONS   ", 17
CtrText "  QUIT GAME ", 19
CtrText "(c)2005 Half-Eaten Software", 24
CtrText "Programmer: Mike Chambers ", 25

CASE 2
CtrText "  START GAME", 15
CtrText CHR$(16) + " OPTIONS   ", 17
CtrText "  QUIT GAME ", 19
CtrText "(c)2005 Half-Eaten Software", 24
CtrText "Programmer: Mike Chambers ", 25

CASE 3
CtrText "  START GAME", 15
CtrText "  OPTIONS   ", 17
CtrText CHR$(16) + " QUIT GAME ", 19
CtrText "(c)2005 Half-Eaten Software", 24
CtrText "Programmer: Mike Chambers ", 25
END SELECT

dummy$ = INKEY$
IF dummy$ = CHR$(0) + CHR$(72) THEN
selcur = selcur - 1
IF selcur = 0 THEN selcur = 1
END IF

IF dummy$ = CHR$(0) + CHR$(80) THEN
selcur = selcur + 1
IF selcur = 4 THEN selcur = 3
END IF

SELECT CASE JoyDirection
CASE 1
selcur = selcur - 1
IF selcur = 0 THEN selcur = 1

CASE 5
selcur = selcur + 1
IF selcur = 4 THEN selcur = 3
END SELECT

IF JoyButton1 = 1 OR JoyButton2 = 1 OR dummy$ = CHR$(13) THEN
SELECT CASE selcur
CASE 1
NextLevel = 1
LevelTitle = ""
CurrentLevel = -1
CLS
EXIT SUB

CASE 2
oldmove = moveup
OptionsMenu oldmove
moveup = oldmove

CASE 3
SCREEN 0: WIDTH 80: COLOR 7, 0: CLS
PRINT "MarioQB v0.5 alpha (c)2005 Half-Eaten Software."
PRINT "Programmed by: Mike Chambers"
PRINT
COLOR 15, 0: PRINT "THIS IS AN EARLY TEST RELEASE": COLOR 7, 0
PRINT "http://dextrometh.com/MarioQB"
END
END SELECT
END IF

DO: LOOP UNTIL JoyButton1 = 0 AND JoyButton2 = 0 AND JoyDirection = 0
LOOP
END SUB

